package ShowXPath.StackNode;

import java.util.*;
import java.io.*;

public class LBoolean implements LStackNode
{
	private boolean _value;
	private final static String _type = "LBoolean";

	public String type()
	{
		return _type;
	}

	public LBoolean(boolean v)
	{
		_value = v;
	}

	public LBoolean(LString s)
	{
		if (s.toString().length() > 0)
		{
			_value = true;
		}
		else
		{
			_value = false;
		}
	}

	public LBoolean(LNodeset n)
	{
		_value = n.toLBoolean().getValue();
	}

	public void setValue(boolean v)
	{
		_value = v;
	}

	public boolean getValue()
	{
		return _value;
	}

	public String toString()
	{
		return new Boolean(_value).toString();
	}

	public LBoolean toLBoolean()
	{
		return this;
	}

	public LNumber toLNumber()
	{
		if (_value)
		{
			return new LNumber(1);
		}
		else
		{
			return new LNumber(0);
		}
	}

	public LString toLString()
	{
		if (_value)
		{
			return new LString("true");
		}
		else
		{
			return new LString("false");
		}
	}

	public String getStringValue()
	{
		if (_value)
		{
			return "true";
		}
		else
		{
			return "false";
		}
	}

	public boolean equals(LStackNode node)
	{
		if (node instanceof LNodeset)
		{
			return (_value == ((LNodeset)node).toLBoolean().getValue());
		}
		else if (node instanceof LBoolean)
		{
			return (_value == ((LBoolean)node).getValue());
		}
		else if (node instanceof LString)
		{
			return (_value == ((LString)node).toLBoolean().getValue());
		}
		else if (node instanceof LNumber)
		{
			return (_value == ((LNumber)node).toLBoolean().getValue());
		}
		else
		{
			return false;
		}
	}
	
	public boolean less(LStackNode node)
	{
		if (node instanceof LNodeset)
		{
			return toLNumber().getValue() <
				((LNodeset)node).toLBoolean().toLNumber().getValue();
		}
		else if (node instanceof LBoolean)
		{
			return toLNumber().getValue() <
				((LBoolean)node).toLNumber().getValue();
		}
		else if (node instanceof LString)
		{
			return toLNumber().getValue() <
				((LString)node).toLNumber().getValue();
		}
		else if (node instanceof LNumber)
		{
			return toLNumber().getValue() <
				((LNumber)node).getValue();
		}
		else
		{
			return false;
		}
	}

	public boolean greater(LStackNode node)
	{
		if (node instanceof LNodeset)
		{
			return toLNumber().getValue() >
				((LNodeset)node).toLBoolean().toLNumber().getValue();
		}
		else if (node instanceof LBoolean)
		{
			return toLNumber().getValue() >
				((LBoolean)node).toLNumber().getValue();
		}
		else if (node instanceof LString)
		{
			return toLNumber().getValue() >
				((LString)node).toLNumber().getValue();
		}
		else if (node instanceof LNumber)
		{
			return toLNumber().getValue() >
				((LNumber)node).getValue();
		}
		else
		{
			return false;
		}
	}

	public boolean lessEquals(LStackNode node)
	{
		if (node instanceof LNodeset)
		{
			return toLNumber().getValue() <=
				((LNodeset)node).toLBoolean().toLNumber().getValue();
		}
		else if (node instanceof LBoolean)
		{
			return toLNumber().getValue() <=
				((LBoolean)node).toLNumber().getValue();
		}
		else if (node instanceof LString)
		{
			return toLNumber().getValue() <=
				((LString)node).toLNumber().getValue();
		}
		else if (node instanceof LNumber)
		{
			return toLNumber().getValue() <=
				((LNumber)node).getValue();
		}
		else
		{
			return false;
		}
	}

	public boolean greaterEquals(LStackNode node)
	{
		if (node instanceof LNodeset)
		{
			return toLNumber().getValue() >=
				((LNodeset)node).toLBoolean().toLNumber().getValue();
		}
		else if (node instanceof LBoolean)
		{
			return toLNumber().getValue() >=
				((LBoolean)node).toLNumber().getValue();
		}
		else if (node instanceof LString)
		{
			return toLNumber().getValue() >=
				((LString)node).toLNumber().getValue();
		}
		else if (node instanceof LNumber)
		{
			return toLNumber().getValue() >=
				((LNumber)node).getValue();
		}
		else
		{
			return false;
		}
	}
}
