package ShowXPath.StackNode;

import java.io.*;
import java.util.*;
import ShowXPath.TreeNode.*;

public class LQname implements LStackNode
{
	private String _namespace;
	private String _local_name;
	private String _original_name;
	private String _URI;
	private final static String _type = "LQname";

	public String type()
	{
		return _type;
	}

	public String toString()
	{
		return "[" + _namespace + ", " + _local_name + ", " + _URI + "]";
	}

	public String getStringValue()
	{
		if (_namespace != null && !_namespace.equals(""))
		{
			return _namespace + ":" + _local_name;
		}
		else
		{
			return _local_name;
		}
	}

	public LQname(String space, String local)
	{
		_namespace = space;
		_local_name = local;
	}

	public LQname(String name)
	{
		_original_name = name;
		_URI = "";
		
		if (name.startsWith("xmlns:"))
		{
			_namespace = "xmlns";
			_local_name = name.substring("xmlns".length());
		}
		else if (name.equals("xmlns"))
		{
			_namespace = "xmlns";
			_local_name = "";
		}
		else {
			int nsIndex = name.indexOf(':');
			if (nsIndex != -1)
			{
				_namespace = name.substring(0, nsIndex);
				_local_name = name.substring(nsIndex + 1);
			}
			else
			{
				_namespace = "";
				_local_name = name;
			}
		}
	}

	public LQname(String name, Hashtable spaces)
	{
		_original_name = name;
		
		if (name.startsWith("xmlns:"))
		{
			_namespace = "xmlns";
			_local_name = name.substring("xmlns".length());
			_URI = "";
		}
		else if (name.equals("xmlns"))
		{
			_namespace = "xmlns";
			_local_name = "";
			_URI = "";
		}
		else {
			int nsIndex = name.indexOf(':');
			if (nsIndex != -1)
			{
				_namespace = name.substring(0, nsIndex);
				_local_name = name.substring(nsIndex + 1);
				_URI = (String) spaces.get(_namespace);
			}
			else
			{
				_namespace = "";
				_local_name = name;
				_URI = (String) spaces.get("");
			}
		}
	}

	public String getLocalName()
	{
		return _local_name;
	}

	public String getNamespace()
	{
		return _namespace;
	}

	public String getURI()
	{
		return _URI;
	}

	public LString toLString()
	{
		return null;
	}

	public LBoolean toLBoolean()
	{
		return null;
	}

	public LNumber toLNumber()
	{
		return null;
	}
	
	public boolean equals(LStackNode node)
	{
		return false;
	}
	
	public boolean less(LStackNode node)
	{
		return false;
	}
	
	public boolean greater(LStackNode node)
	{
		return false;
	}
	
	public boolean lessEquals(LStackNode node)
	{
		return false;
	}
	
	public boolean greaterEquals(LStackNode node)
	{
		return false;
	}
	
}
