package ShowXPath.TreeNode;

import java.util.*;
import ShowXPath.StackNode.*;

public class LComment extends LTreeNode
{
	private String _value;
	private LTreeNode _parent;
	private static String _type = "LComment";

	public String getLang()
	{
		return _parent.getLang();
	}

	public LRoot getRoot()
	{
		return _parent.getRoot();
	}

	public LTreeNode getParent()
	{
		return _parent;
	}

	public String type()
	{
		return _type;
	}

	public LComment(String value, LTreeNode parent)
	{
		_value = value;
		_parent = parent;
		setID();
	}

	public String getStringValue()
	{
		return _value;
	}

	public String getName()
	{
		return "";
	}

	public String getLocal_name()
	{
		return "";
	}

	public String getNamespace()
	{
		return "";
	}

	public String getNamespace_uri()
	{
		return "";
	}

	public String toString()
	{
		return "<!-- " + _value + "-->";
	}
	
	public String getNodeStringValue()
	{
		return "<!-- " + "{" + _order + "}" + _value + " -->";
	}
	
	public LNodeset parent()
	{
		LNodeset list = new LNodeset();
		list.add(_parent);
		return list;
	}

	public LNodeset child()
	{
		LNodeset list = new LNodeset();
		return list;
	}

	public LNodeset ancestor()
	{
		LNodeset list = _parent.ancestor_or_self();
		return list;
	}

	public LNodeset self()
	{
		LNodeset list = new LNodeset();
		list.add(this);
		return list;
	}

	public LNodeset ancestor_or_self()
	{
		LNodeset list = _parent.ancestor_or_self();
		list.add(this);
		return list;
	}

	public LNodeset descendent()
	{
		LNodeset list = new LNodeset();
		return list;
	}

	public LNodeset descendent_or_self()
	{
		LNodeset list = new LNodeset();
		list.add(this);
		return list;
	}

	public LNodeset attribute()
	{
		LNodeset list = new LNodeset();
		return list;
	}

	public LNodeset following_sibling()
	{
		LNodeset list = _parent.child();
		Iterator i = list.listIterator();
		while (i.hasNext())
		{
			LTreeNode n = (LTreeNode)i.next();
			if (n.getOrder() <= _order)
			{
				i.remove();
			}
		}
		return list;
	}

	public LNodeset following()
	{
		LNodeset list = root();
		list = ((LTreeNode)list.getFirst()).descendent();
		ListIterator i = list.listIterator();
		while (i.hasNext())
		{
			LTreeNode n = (LTreeNode)i.next();
			if (n.getOrder() <= _order)
			{
				i.remove();
			}
		}
		return list;
	}

	public LNodeset preceding_sibling()
	{
		LNodeset list = _parent.child();
		Iterator i = list.listIterator();
		while (i.hasNext())
		{
			LTreeNode n = (LTreeNode)i.next();
			if (n.getOrder() >= _order)
			{
				i.remove();
			}
		}
		return list;
	}

	public LNodeset preceding()
	{
		LNodeset list = root();
		list = ((LTreeNode)list.getFirst()).descendent();
		ListIterator i = list.listIterator();
		while (i.hasNext())
		{
			LTreeNode n = (LTreeNode) i.next();
			if (n.getOrder() >= _order)
			{
				i.remove();
			}
		}
		return list;
	}

	public LNodeset namespace()
	{
		LNodeset list = new LNodeset();
		return list;
	}

	public String showNode()
	{
		return toString();
	}

	public LString toLString()
	{
		return new LString(_value);
	}

	public LNumber toLNumber()
	{
		return new LString(_value).toLNumber();
	}

	public LBoolean toLBoolean()
	{
		return new LString(_value).toLBoolean();
	}
}
