/* This file was generated by SableCC (http://www.sable.mcgill.ca/sablecc/). */

package ShowXPath.XPath.lexer;

import java.io.*;
import java.util.*;
import ShowXPath.XPath.node.*;

public class Lexer
{
    protected Token token;
    protected State state = State.INITIAL;

    private PushbackReader in;
    private int line;
    private int pos;
    private boolean cr;
    private boolean eof;
    private final StringBuffer text = new StringBuffer();

    protected void filter() throws LexerException, IOException
    {
    }

    public Lexer(PushbackReader in)
    {
        this.in = in;

        if(gotoTable == null)
        {
            try
            {
                DataInputStream s = new DataInputStream(
                    new BufferedInputStream(
                    Lexer.class.getResourceAsStream("lexer.dat")));

                // read gotoTable
                int length = s.readInt();
                gotoTable = new int[length][][][];
                for(int i = 0; i < gotoTable.length; i++)
                {
                    length = s.readInt();
                    gotoTable[i] = new int[length][][];
                    for(int j = 0; j < gotoTable[i].length; j++)
                    {
                        length = s.readInt();
                        gotoTable[i][j] = new int[length][3];
                        for(int k = 0; k < gotoTable[i][j].length; k++)
                        {
                            for(int l = 0; l < 3; l++)
                            {
                                gotoTable[i][j][k][l] = s.readInt();
                            }
                        }
                    }
                }

                // read accept
                length = s.readInt();
                accept = new int[length][];
                for(int i = 0; i < accept.length; i++)
                {
                    length = s.readInt();
                    accept[i] = new int[length];
                    for(int j = 0; j < accept[i].length; j++)
                    {
                        accept[i][j] = s.readInt();
                    }
                }

                s.close();
            }
            catch(Exception e)
            {
                throw new RuntimeException("Unable to read lexer.dat.");
            }
        }
    }

    public Token peek() throws LexerException, IOException
    {
        while(token == null)
        {
            token = getToken();
            filter();
        }

        return token;
    }

    public Token next() throws LexerException, IOException
    {
        while(token == null)
        {
            token = getToken();
            filter();
        }

        Token result = token;
        token = null;
        return result;
    }

    protected Token getToken() throws IOException, LexerException
    {
        int dfa_state = 0;

        int start_pos = pos;
        int start_line = line;

        int accept_state = -1;
        int accept_token = -1;
        int accept_length = -1;
        int accept_pos = -1;
        int accept_line = -1;

	int[][][] gotoTable = this.gotoTable[state.id()];
	int[] accept = this.accept[state.id()];
        text.setLength(0);

        while(true)
        {
            int c = getChar();

            if(c != -1)
            {
                switch(c)
                {
                case 10:
                    if(cr)
                    {
                        cr = false;
                    }
                    else
                    {
                        line++;
                        pos = 0;
                    }
                    break;
                case 13:
                    line++;
                    pos = 0;
                    cr = true;
                    break;
                default:
                    pos++;
                    cr = false;
                    break;
                };

                text.append((char) c);

                do
                {
                    int oldState = (dfa_state < -1) ? (-2 -dfa_state) : dfa_state;

                    dfa_state = -1;

                    int[][] tmp1 =  gotoTable[oldState];
                    int low = 0;
                    int high = tmp1.length - 1;

                    while(low <= high)
                    {
                        int middle = (low + high) / 2;
                        int[] tmp2 = tmp1[middle];

                        if(c < tmp2[0])
                        {
                            high = middle - 1;
                        }
                        else if(c > tmp2[1])
                        {
                            low = middle + 1;
                        }
                        else
                        {
                            dfa_state = tmp2[2];
                            break;
                        }
                    }
                }while(dfa_state < -1);
            }
            else
            {
                dfa_state = -1;
            }

            if(dfa_state >= 0)
            {
                if(accept[dfa_state] != -1)
                {
                    accept_state = dfa_state;
                    accept_token = accept[dfa_state];
                    accept_length = text.length();
                    accept_pos = pos;
                    accept_line = line;
                }
            }
            else
            {
                if(accept_state != -1)
                {
                    switch(accept_token)
                    {
                    case 0:
                        {
                            Token token = new0(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 1:
                        {
                            Token token = new1(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 2:
                        {
                            Token token = new2(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 3:
                        {
                            Token token = new3(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 4:
                        {
                            Token token = new4(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 5:
                        {
                            Token token = new5(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 6:
                        {
                            Token token = new6(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 7:
                        {
                            Token token = new7(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 8:
                        {
                            Token token = new8(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 9:
                        {
                            Token token = new9(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 10:
                        {
                            Token token = new10(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 11:
                        {
                            Token token = new11(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 12:
                        {
                            Token token = new12(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 13:
                        {
                            Token token = new13(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 14:
                        {
                            Token token = new14(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 15:
                        {
                            Token token = new15(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 16:
                        {
                            Token token = new16(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 17:
                        {
                            Token token = new17(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 18:
                        {
                            Token token = new18(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 19:
                        {
                            Token token = new19(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 20:
                        {
                            Token token = new20(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 21:
                        {
                            Token token = new21(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 22:
                        {
                            Token token = new22(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 23:
                        {
                            Token token = new23(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 24:
                        {
                            Token token = new24(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 25:
                        {
                            Token token = new25(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 26:
                        {
                            Token token = new26(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 27:
                        {
                            Token token = new27(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 28:
                        {
                            Token token = new28(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 29:
                        {
                            Token token = new29(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 30:
                        {
                            Token token = new30(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 31:
                        {
                            Token token = new31(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 32:
                        {
                            Token token = new32(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 33:
                        {
                            Token token = new33(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 34:
                        {
                            Token token = new34(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 35:
                        {
                            Token token = new35(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 36:
                        {
                            Token token = new36(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 37:
                        {
                            Token token = new37(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 38:
                        {
                            Token token = new38(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 39:
                        {
                            Token token = new39(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 40:
                        {
                            Token token = new40(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 41:
                        {
                            Token token = new41(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 42:
                        {
                            Token token = new42(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 43:
                        {
                            Token token = new43(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 44:
                        {
                            Token token = new44(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 45:
                        {
                            Token token = new45(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 46:
                        {
                            Token token = new46(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 47:
                        {
                            Token token = new47(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 48:
                        {
                            Token token = new48(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 49:
                        {
                            Token token = new49(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 50:
                        {
                            Token token = new50(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 51:
                        {
                            Token token = new51(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 52:
                        {
                            Token token = new52(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 53:
                        {
                            Token token = new53(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 54:
                        {
                            Token token = new54(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 55:
                        {
                            Token token = new55(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 56:
                        {
                            Token token = new56(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 57:
                        {
                            Token token = new57(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 58:
                        {
                            Token token = new58(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 59:
                        {
                            Token token = new59(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 60:
                        {
                            Token token = new60(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 61:
                        {
                            Token token = new61(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 62:
                        {
                            Token token = new62(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 63:
                        {
                            Token token = new63(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 64:
                        {
                            Token token = new64(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 65:
                        {
                            Token token = new65(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 66:
                        {
                            Token token = new66(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 67:
                        {
                            Token token = new67(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 68:
                        {
                            Token token = new68(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 69:
                        {
                            Token token = new69(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 70:
                        {
                            Token token = new70(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 71:
                        {
                            Token token = new71(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 72:
                        {
                            Token token = new72(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 73:
                        {
                            Token token = new73(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 74:
                        {
                            Token token = new74(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 75:
                        {
                            Token token = new75(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 76:
                        {
                            Token token = new76(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 77:
                        {
                            Token token = new77(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 78:
                        {
                            Token token = new78(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 79:
                        {
                            Token token = new79(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 80:
                        {
                            Token token = new80(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 81:
                        {
                            Token token = new81(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 82:
                        {
                            Token token = new82(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 83:
                        {
                            Token token = new83(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 84:
                        {
                            Token token = new84(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    }
                }
                else
                {
                    if(text.length() > 0)
                    {
                        throw new LexerException(
                            "[" + (start_line + 1) + "," + (start_pos + 1) + "]" +
                            " Unknown token: " + text);
                    }
                    else
                    {
                        EOF token = new EOF(
                            start_line + 1,
                            start_pos + 1);
                        return token;
                    }
                }
            }
        }
    }

    Token new0(String text, int line, int pos) { return new TProcessingInstructionTok(text, line, pos); }
    Token new1(String text, int line, int pos) { return new TUnparsedEntityUriTok(text, line, pos); }
    Token new2(int line, int pos) { return new TDescendentOrSelfTok(line, pos); }
    Token new3(String text, int line, int pos) { return new TFunctionAvailableTok(text, line, pos); }
    Token new4(int line, int pos) { return new TFollowingSiblingTok(line, pos); }
    Token new5(int line, int pos) { return new TPrecedingSiblingTok(line, pos); }
    Token new6(String text, int line, int pos) { return new TElementAvailableTok(text, line, pos); }
    Token new7(String text, int line, int pos) { return new TSubstringBeforeTok(text, line, pos); }
    Token new8(int line, int pos) { return new TAncestorOrSelfTok(line, pos); }
    Token new9(String text, int line, int pos) { return new TSubstringAfterTok(text, line, pos); }
    Token new10(String text, int line, int pos) { return new TNormalizeSpaceTok(text, line, pos); }
    Token new11(String text, int line, int pos) { return new TSystemPropertyTok(text, line, pos); }
    Token new12(String text, int line, int pos) { return new TStringLengthTok(text, line, pos); }
    Token new13(String text, int line, int pos) { return new TNamespaceUriTok(text, line, pos); }
    Token new14(String text, int line, int pos) { return new TFormatNumberTok(text, line, pos); }
    Token new15(String text, int line, int pos) { return new TNumberStringTok(text, line, pos); }
    Token new16(String text, int line, int pos) { return new TGenerateIdTok(text, line, pos); }
    Token new17(String text, int line, int pos) { return new TStartsWithTok(text, line, pos); }
    Token new18(int line, int pos) { return new TDescendentTok(line, pos); }
    Token new19(String text, int line, int pos) { return new TLocalNameTok(text, line, pos); }
    Token new20(int line, int pos) { return new TNamespaceTok(line, pos); }
    Token new21(int line, int pos) { return new TFollowingTok(line, pos); }
    Token new22(int line, int pos) { return new TPrecedingTok(line, pos); }
    Token new23(String text, int line, int pos) { return new TTranslateTok(text, line, pos); }
    Token new24(String text, int line, int pos) { return new TSubstringTok(text, line, pos); }
    Token new25(int line, int pos) { return new TAttributeTok(line, pos); }
    Token new26(String text, int line, int pos) { return new TDocumentTok(text, line, pos); }
    Token new27(String text, int line, int pos) { return new TContainsTok(text, line, pos); }
    Token new28(String text, int line, int pos) { return new TPositionTok(text, line, pos); }
    Token new29(int line, int pos) { return new TAncestorTok(line, pos); }
    Token new30(String text, int line, int pos) { return new TCeilingTok(text, line, pos); }
    Token new31(String text, int line, int pos) { return new TCurrentTok(text, line, pos); }
    Token new32(String text, int line, int pos) { return new TCommentTok(text, line, pos); }
    Token new33(String text, int line, int pos) { return new TBooleanTok(text, line, pos); }
    Token new34(int line, int pos) { return new TParentTok(line, pos); }
    Token new35(String text, int line, int pos) { return new TStringTok(text, line, pos); }
    Token new36(String text, int line, int pos) { return new TConcatTok(text, line, pos); }
    Token new37(String text, int line, int pos) { return new TCountTok(text, line, pos); }
    Token new38(String text, int line, int pos) { return new TFalseTok(text, line, pos); }
    Token new39(String text, int line, int pos) { return new TRoundTok(text, line, pos); }
    Token new40(String text, int line, int pos) { return new TFloorTok(text, line, pos); }
    Token new41(int line, int pos) { return new TChildTok(line, pos); }
    Token new42(String text, int line, int pos) { return new TLastTok(text, line, pos); }
    Token new43(String text, int line, int pos) { return new TTrueTok(text, line, pos); }
    Token new44(String text, int line, int pos) { return new TNameTok(text, line, pos); }
    Token new45(String text, int line, int pos) { return new TLangTok(text, line, pos); }
    Token new46(int line, int pos) { return new TSelfTok(line, pos); }
    Token new47(String text, int line, int pos) { return new TTextTok(text, line, pos); }
    Token new48(String text, int line, int pos) { return new TNodeTok(text, line, pos); }
    Token new49(String text, int line, int pos) { return new TKeyTok(text, line, pos); }
    Token new50(int line, int pos) { return new TAndTok(line, pos); }
    Token new51(int line, int pos) { return new TDivTok(line, pos); }
    Token new52(int line, int pos) { return new TModTok(line, pos); }
    Token new53(String text, int line, int pos) { return new TNotTok(text, line, pos); }
    Token new54(String text, int line, int pos) { return new TSumTok(text, line, pos); }
    Token new55(String text, int line, int pos) { return new TIdTok(text, line, pos); }
    Token new56(int line, int pos) { return new TAxisTok(line, pos); }
    Token new57(int line, int pos) { return new TColonTok(line, pos); }
    Token new58(int line, int pos) { return new TKleeneTok(line, pos); }
    Token new59(int line, int pos) { return new TStarTok(line, pos); }
    Token new60(int line, int pos) { return new TLeftParenTok(line, pos); }
    Token new61(int line, int pos) { return new TRightParenTok(line, pos); }
    Token new62(String text, int line, int pos) { return new TLiteralTok(text, line, pos); }
    Token new63(String text, int line, int pos) { return new TNumberTok(text, line, pos); }
    Token new64(int line, int pos) { return new TAtSignTok(line, pos); }
    Token new65(int line, int pos) { return new TDollarTok(line, pos); }
    Token new66(int line, int pos) { return new TCommaTok(line, pos); }
    Token new67(int line, int pos) { return new TDoubleslashTok(line, pos); }
    Token new68(int line, int pos) { return new TSlashTok(line, pos); }
    Token new69(int line, int pos) { return new TLeftSquareTok(line, pos); }
    Token new70(int line, int pos) { return new TRightSquareTok(line, pos); }
    Token new71(int line, int pos) { return new TDotTok(line, pos); }
    Token new72(int line, int pos) { return new TDoubledotTok(line, pos); }
    Token new73(int line, int pos) { return new TBarTok(line, pos); }
    Token new74(int line, int pos) { return new TPlusTok(line, pos); }
    Token new75(int line, int pos) { return new TMinusTok(line, pos); }
    Token new76(int line, int pos) { return new TEqualTok(line, pos); }
    Token new77(int line, int pos) { return new TNotEqualTok(line, pos); }
    Token new78(int line, int pos) { return new TOrTok(line, pos); }
    Token new79(int line, int pos) { return new TLessTok(line, pos); }
    Token new80(int line, int pos) { return new TGreaterTok(line, pos); }
    Token new81(int line, int pos) { return new TLessEqualTok(line, pos); }
    Token new82(int line, int pos) { return new TGreaterEqualTok(line, pos); }
    Token new83(String text, int line, int pos) { return new TBlankTok(text, line, pos); }
    Token new84(String text, int line, int pos) { return new TNcnameTok(text, line, pos); }

    private int getChar() throws IOException
    {
        if(eof)
        {
            return -1;
        }

        int result = in.read();

        if(result == -1)
        {
            eof = true;
        }

        return result;
    }

    private void pushBack(int acceptLength) throws IOException
    {
        int length = text.length();
        for(int i = length - 1; i >= acceptLength; i--)
        {
            eof = false;

            in.unread(text.charAt(i));
        }
    }

    protected void unread(Token token) throws IOException
    {
        String text = token.getText();
        int length = text.length();

        for(int i = length - 1; i >= 0; i--)
        {
            eof = false;

            in.unread(text.charAt(i));
        }

        pos = token.getPos() - 1;
        line = token.getLine() - 1;
    }

    private String getText(int acceptLength)
    {
        StringBuffer s = new StringBuffer(acceptLength);
        for(int i = 0; i < acceptLength; i++)
        {
            s.append(text.charAt(i));
        }

        return s.toString();
    }

    private static int[][][][] gotoTable;
/*  {
        { // INITIAL
            {{9, 9, 1}, {10, 10, 2}, {13, 13, 3}, {32, 32, 4}, {33, 33, 5}, {34, 34, 6}, {36, 36, 7}, {39, 39, 8}, {40, 40, 9}, {41, 41, 10}, {42, 42, 11}, {43, 43, 12}, {44, 44, 13}, {45, 45, 14}, {46, 46, 15}, {47, 47, 16}, {48, 57, 17}, {58, 58, 18}, {60, 60, 19}, {61, 61, 20}, {62, 62, 21}, {64, 64, 22}, {65, 90, 23}, {91, 91, 24}, {93, 93, 25}, {95, 95, 26}, {97, 97, 27}, {98, 98, 28}, {99, 99, 29}, {100, 100, 30}, {101, 101, 31}, {102, 102, 32}, {103, 103, 33}, {104, 104, 23}, {105, 105, 34}, {106, 106, 23}, {107, 107, 35}, {108, 108, 36}, {109, 109, 37}, {110, 110, 38}, {111, 111, 39}, {112, 112, 40}, {113, 113, 23}, {114, 114, 41}, {115, 115, 42}, {116, 116, 43}, {117, 117, 44}, {118, 122, 23}, {124, 124, 45}, },
            {{9, 32, -2}, },
            {{9, 32, -2}, },
            {{9, 32, -2}, },
            {{9, 32, -2}, },
            {{61, 61, 46}, },
            {{0, 33, 47}, {34, 34, 48}, {35, 65535, 47}, },
            {},
            {{0, 38, 49}, {39, 39, 50}, {40, 65535, 49}, },
            {},
            {},
            {},
            {},
            {},
            {},
            {{46, 46, 51}, {48, 57, 52}, },
            {{47, 47, 53}, },
            {{46, 46, 54}, {48, 57, 17}, },
            {{58, 58, 55}, },
            {{61, 61, 56}, },
            {},
            {{61, 61, 57}, },
            {},
            {{45, 45, 58}, {46, 46, 59}, {48, 57, 60}, {65, 90, 61}, {95, 95, 62}, {97, 122, 61}, },
            {},
            {},
            {{45, 122, -25}, },
            {{45, 95, -25}, {97, 109, 61}, {110, 110, 63}, {111, 115, 61}, {116, 116, 64}, {117, 122, 61}, },
            {{45, 95, -25}, {97, 110, 61}, {111, 111, 65}, {112, 122, 61}, },
            {{45, 95, -25}, {97, 100, 61}, {101, 101, 66}, {102, 103, 61}, {104, 104, 67}, {105, 110, 61}, {111, 111, 68}, {112, 116, 61}, {117, 117, 69}, {118, 122, 61}, },
            {{45, 100, -31}, {101, 101, 70}, {102, 104, 61}, {105, 105, 71}, {106, 110, 61}, {111, 111, 72}, {112, 122, 61}, },
            {{45, 95, -25}, {97, 107, 61}, {108, 108, 73}, {109, 122, 61}, },
            {{45, 95, -25}, {97, 97, 74}, {98, 107, 61}, {108, 108, 75}, {109, 110, 61}, {111, 111, 76}, {112, 116, 61}, {117, 117, 77}, {118, 122, 61}, },
            {{45, 100, -31}, {101, 101, 78}, {102, 122, 61}, },
            {{45, 95, -25}, {97, 99, 61}, {100, 100, 79}, {101, 122, 61}, },
            {{45, 100, -31}, {101, 101, 80}, {102, 122, 61}, },
            {{45, 95, -25}, {97, 97, 81}, {98, 110, 61}, {111, 111, 82}, {112, 122, 61}, },
            {{45, 110, -30}, {111, 111, 83}, {112, 122, 61}, },
            {{45, 95, -25}, {97, 97, 84}, {98, 110, 61}, {111, 111, 85}, {112, 116, 61}, {117, 117, 86}, {118, 122, 61}, },
            {{45, 95, -25}, {97, 113, 61}, {114, 114, 87}, {115, 122, 61}, },
            {{45, 95, -25}, {97, 97, 88}, {98, 110, 61}, {111, 111, 89}, {112, 113, 61}, {114, 114, 90}, {115, 122, 61}, },
            {{45, 110, -30}, {111, 111, 91}, {112, 122, 61}, },
            {{45, 100, -31}, {101, 101, 92}, {102, 115, 61}, {116, 116, 93}, {117, 117, 94}, {118, 120, 61}, {121, 121, 95}, {122, 122, 61}, },
            {{45, 100, -31}, {101, 101, 96}, {102, 113, 61}, {114, 114, 97}, {115, 122, 61}, },
            {{45, 109, -29}, {110, 110, 98}, {111, 122, 61}, },
            {},
            {},
            {{0, 65535, -8}, },
            {},
            {{0, 65535, -10}, },
            {},
            {},
            {{48, 57, 52}, },
            {},
            {{48, 57, 99}, },
            {},
            {},
            {},
            {{45, 122, -25}, },
            {{45, 122, -25}, },
            {{45, 122, -25}, },
            {{45, 122, -25}, },
            {{45, 122, -25}, },
            {{45, 95, -25}, {97, 98, 61}, {99, 99, 100}, {100, 100, 101}, {101, 122, 61}, },
            {{45, 95, -25}, {97, 115, 61}, {116, 116, 102}, {117, 122, 61}, },
            {{45, 110, -30}, {111, 111, 103}, {112, 122, 61}, },
            {{45, 95, -25}, {97, 104, 61}, {105, 105, 104}, {106, 122, 61}, },
            {{45, 104, -68}, {105, 105, 105}, {106, 122, 61}, },
            {{45, 95, -25}, {97, 108, 61}, {109, 109, 106}, {110, 110, 107}, {111, 116, 61}, {117, 117, 108}, {118, 122, 61}, },
            {{45, 113, -41}, {114, 114, 109}, {115, 122, 61}, },
            {{45, 95, -25}, {97, 114, 61}, {115, 115, 110}, {116, 122, 61}, },
            {{45, 95, -25}, {97, 117, 61}, {118, 118, 111}, {119, 122, 61}, },
            {{45, 98, -65}, {99, 99, 112}, {100, 122, 61}, },
            {{45, 100, -31}, {101, 101, 113}, {102, 122, 61}, },
            {{45, 107, -33}, {108, 108, 114}, {109, 122, 61}, },
            {{45, 110, -30}, {111, 111, 115}, {112, 122, 61}, },
            {{45, 107, -33}, {108, 108, 116}, {109, 113, 61}, {114, 114, 117}, {115, 122, 61}, },
            {{45, 109, -29}, {110, 110, 118}, {111, 122, 61}, },
            {{45, 109, -29}, {110, 110, 119}, {111, 122, 61}, },
            {{9, 9, 120}, {10, 10, 121}, {13, 13, 122}, {40, 40, 123}, {45, 122, -25}, },
            {{45, 95, -25}, {97, 120, 61}, {121, 121, 124}, {122, 122, 61}, },
            {{45, 109, -29}, {110, 110, 125}, {111, 114, 61}, {115, 115, 126}, {116, 122, 61}, },
            {{45, 98, -65}, {99, 99, 127}, {100, 122, 61}, },
            {{45, 99, -36}, {100, 100, 128}, {101, 122, 61}, },
            {{45, 108, -70}, {109, 109, 129}, {110, 122, 61}, },
            {{45, 99, -36}, {100, 100, 130}, {101, 113, 61}, {114, 114, 131}, {115, 115, 61}, {116, 116, 132}, {117, 122, 61}, },
            {{45, 108, -70}, {109, 109, 133}, {110, 122, 61}, },
            {{45, 122, -25}, },
            {{45, 113, -41}, {114, 114, 134}, {115, 122, 61}, },
            {{45, 114, -72}, {115, 115, 135}, {116, 122, 61}, },
            {{45, 100, -31}, {101, 101, 136}, {102, 110, 61}, {111, 111, 137}, {112, 122, 61}, },
            {{45, 95, -25}, {97, 116, 61}, {117, 117, 138}, {118, 122, 61}, },
            {{45, 107, -33}, {108, 108, 139}, {109, 122, 61}, },
            {{45, 95, -25}, {97, 97, 140}, {98, 113, 61}, {114, 114, 141}, {115, 122, 61}, },
            {{45, 95, -25}, {97, 97, 61}, {98, 98, 142}, {99, 108, 61}, {109, 109, 143}, {110, 122, 61}, },
            {{45, 114, -72}, {115, 115, 144}, {116, 122, 61}, },
            {{45, 95, -25}, {97, 119, 61}, {120, 120, 145}, {121, 122, 61}, },
            {{45, 95, -25}, {97, 97, 146}, {98, 116, 61}, {117, 117, 147}, {118, 122, 61}, },
            {{45, 95, -25}, {97, 111, 61}, {112, 112, 148}, {113, 122, 61}, },
            {{48, 57, 99}, },
            {{45, 100, -31}, {101, 101, 149}, {102, 122, 61}, },
            {{45, 122, -25}, },
            {{45, 113, -41}, {114, 114, 150}, {115, 122, 61}, },
            {{45, 107, -33}, {108, 108, 151}, {109, 122, 61}, },
            {{45, 107, -33}, {108, 108, 152}, {109, 122, 61}, },
            {{45, 107, -33}, {108, 108, 153}, {109, 122, 61}, },
            {{45, 108, -70}, {109, 109, 154}, {110, 122, 61}, },
            {{45, 98, -65}, {99, 99, 155}, {100, 115, 61}, {116, 116, 156}, {117, 122, 61}, },
            {{45, 109, -29}, {110, 110, 157}, {111, 122, 61}, },
            {{45, 113, -41}, {114, 114, 158}, {115, 122, 61}, },
            {{45, 98, -65}, {99, 99, 159}, {100, 122, 61}, },
            {{45, 122, -25}, },
            {{45, 116, -93}, {117, 117, 160}, {118, 122, 61}, },
            {{45, 108, -70}, {109, 109, 161}, {110, 122, 61}, },
            {{45, 114, -72}, {115, 115, 162}, {116, 122, 61}, },
            {{45, 110, -30}, {111, 111, 163}, {112, 122, 61}, },
            {{45, 107, -33}, {108, 108, 164}, {109, 122, 61}, },
            {{45, 108, -70}, {109, 109, 165}, {110, 122, 61}, },
            {{45, 98, -65}, {99, 99, 166}, {100, 122, 61}, },
            {{45, 100, -31}, {101, 101, 167}, {102, 122, 61}, },
            {{9, 40, -81}, },
            {{9, 40, -81}, },
            {{9, 40, -81}, },
            {},
            {{9, 9, 168}, {10, 10, 169}, {13, 13, 170}, {40, 40, 171}, {45, 122, -25}, },
            {{45, 95, -25}, {97, 102, 61}, {103, 103, 172}, {104, 122, 61}, },
            {{45, 115, -66}, {116, 116, 173}, {117, 122, 61}, },
            {{45, 95, -25}, {97, 97, 174}, {98, 122, 61}, },
            {{45, 122, -25}, },
            {{45, 100, -31}, {101, 101, 175}, {102, 122, 61}, },
            {{45, 100, -31}, {101, 101, 176}, {102, 122, 61}, },
            {{45, 108, -70}, {109, 109, 177}, {110, 122, 61}, },
            {{9, 9, 178}, {10, 10, 179}, {13, 13, 180}, {40, 40, 181}, {45, 122, -25}, },
            {{45, 97, -96}, {98, 98, 182}, {99, 122, 61}, },
            {{45, 100, -31}, {101, 101, 183}, {102, 122, 61}, },
            {{45, 104, -68}, {105, 105, 184}, {106, 122, 61}, },
            {{45, 98, -65}, {99, 99, 185}, {100, 122, 61}, },
            {{45, 98, -65}, {99, 99, 186}, {100, 122, 61}, },
            {{45, 109, -29}, {110, 110, 187}, {111, 122, 61}, },
            {{45, 95, -25}, {97, 101, 61}, {102, 102, 188}, {103, 122, 61}, },
            {{45, 113, -41}, {114, 114, 189}, {115, 122, 61}, },
            {{45, 104, -68}, {105, 105, 190}, {106, 122, 61}, },
            {{45, 114, -72}, {115, 115, 191}, {116, 122, 61}, },
            {{9, 9, 192}, {10, 10, 193}, {13, 13, 194}, {40, 40, 195}, {45, 122, -25}, },
            {{45, 115, -66}, {116, 116, 196}, {117, 122, 61}, },
            {{45, 115, -66}, {116, 116, 197}, {117, 122, 61}, },
            {{45, 109, -29}, {110, 110, 198}, {111, 122, 61}, },
            {{45, 100, -31}, {101, 101, 199}, {102, 122, 61}, },
            {{45, 95, -25}, {97, 97, 200}, {98, 122, 61}, },
            {{45, 114, -72}, {115, 115, 201}, {116, 122, 61}, },
            {{45, 104, -68}, {105, 105, 202}, {106, 122, 61}, },
            {{45, 100, -31}, {101, 101, 203}, {102, 122, 61}, },
            {{45, 104, -68}, {105, 105, 204}, {106, 122, 61}, },
            {{45, 99, -36}, {100, 100, 205}, {101, 122, 61}, },
            {{45, 100, -31}, {101, 101, 206}, {102, 122, 61}, },
            {{45, 95, -25}, {97, 97, 207}, {98, 122, 61}, },
            {{45, 95, -25}, {97, 97, 208}, {98, 122, 61}, },
            {{45, 115, -66}, {116, 116, 209}, {117, 122, 61}, },
            {{45, 100, -31}, {101, 101, 210}, {102, 122, 61}, },
            {{45, 100, -31}, {101, 101, 211}, {102, 122, 61}, },
            {{45, 108, -70}, {109, 109, 212}, {110, 122, 61}, },
            {{45, 100, -31}, {101, 101, 213}, {102, 122, 61}, },
            {{45, 100, -31}, {101, 101, 214}, {102, 122, 61}, },
            {{45, 113, -41}, {114, 114, 215}, {115, 122, 61}, },
            {{45, 110, -30}, {111, 111, 216}, {112, 122, 61}, },
            {{45, 95, -25}, {97, 97, 217}, {98, 122, 61}, },
            {{45, 115, -66}, {116, 116, 218}, {117, 122, 61}, },
            {{45, 113, -41}, {114, 114, 219}, {115, 122, 61}, },
            {{9, 40, -126}, },
            {{9, 40, -126}, },
            {{9, 40, -126}, },
            {},
            {{9, 9, 220}, {10, 10, 221}, {13, 13, 222}, {40, 40, 223}, {45, 122, -25}, },
            {{9, 9, 224}, {10, 10, 225}, {13, 13, 226}, {40, 40, 227}, {45, 122, -25}, },
            {{45, 107, -33}, {108, 108, 228}, {109, 122, 61}, },
            {{9, 9, 229}, {10, 10, 230}, {13, 13, 231}, {40, 40, 232}, {45, 114, -72}, {115, 115, 233}, {116, 122, 61}, },
            {{9, 9, 234}, {10, 10, 235}, {13, 13, 236}, {40, 40, 237}, {45, 122, -25}, },
            {{45, 95, -25}, {97, 97, 238}, {98, 122, 61}, },
            {{9, 40, -134}, },
            {{9, 40, -134}, },
            {{9, 40, -134}, },
            {},
            {{45, 100, -31}, {101, 101, 239}, {102, 122, 61}, },
            {{45, 109, -29}, {110, 110, 240}, {111, 122, 61}, },
            {{45, 115, -66}, {116, 116, 241}, {117, 122, 61}, },
            {{45, 100, -31}, {101, 101, 242}, {102, 122, 61}, },
            {{45, 100, -31}, {101, 101, 243}, {102, 122, 61}, },
            {{45, 99, -36}, {100, 100, 244}, {101, 122, 61}, },
            {{45, 122, -25}, },
            {{45, 115, -66}, {116, 116, 245}, {117, 122, 61}, },
            {{45, 109, -29}, {110, 110, 246}, {111, 122, 61}, },
            {{45, 115, -66}, {116, 116, 247}, {117, 122, 61}, },
            {{9, 40, -145}, },
            {{9, 40, -145}, },
            {{9, 40, -145}, },
            {},
            {{45, 100, -31}, {101, 101, 248}, {102, 122, 61}, },
            {{9, 9, 249}, {10, 10, 250}, {13, 13, 251}, {40, 40, 252}, {45, 122, -25}, },
            {{45, 114, -72}, {115, 115, 253}, {116, 122, 61}, },
            {{9, 9, 254}, {10, 10, 255}, {13, 13, 256}, {40, 40, 257}, {45, 122, -25}, },
            {{45, 113, -41}, {114, 114, 258}, {115, 122, 61}, },
            {{45, 115, -66}, {116, 116, 259}, {117, 122, 61}, },
            {{45, 97, -96}, {98, 98, 260}, {99, 122, 61}, },
            {{45, 95, -25}, {97, 97, 261}, {98, 122, 61}, },
            {{45, 109, -29}, {110, 110, 262}, {111, 122, 61}, },
            {{45, 122, -25}, },
            {{45, 109, -29}, {110, 110, 263}, {111, 122, 61}, },
            {{45, 115, -66}, {116, 116, 264}, {117, 122, 61}, },
            {{45, 104, -68}, {105, 105, 265}, {106, 122, 61}, },
            {{9, 9, 266}, {10, 10, 267}, {13, 13, 268}, {40, 40, 269}, {45, 122, -25}, },
            {{45, 109, -29}, {110, 110, 270}, {111, 122, 61}, },
            {{45, 109, -29}, {110, 110, 271}, {111, 122, 61}, },
            {{45, 100, -31}, {101, 101, 272}, {102, 122, 61}, },
            {{45, 109, -29}, {110, 110, 273}, {111, 122, 61}, },
            {{9, 9, 274}, {10, 10, 275}, {13, 13, 276}, {40, 40, 277}, {45, 122, -25}, },
            {{9, 9, 278}, {10, 10, 279}, {13, 13, 280}, {40, 40, 281}, {45, 122, -25}, },
            {{45, 95, -25}, {97, 118, 61}, {119, 119, 282}, {120, 122, 61}, },
            {{45, 115, -66}, {116, 116, 283}, {117, 122, 61}, },
            {{45, 104, -68}, {105, 105, 284}, {106, 122, 61}, },
            {{45, 95, -25}, {97, 97, 285}, {98, 122, 61}, },
            {{9, 40, -174}, },
            {{9, 40, -174}, },
            {{9, 40, -174}, },
            {},
            {{9, 40, -175}, },
            {{9, 40, -175}, },
            {{9, 40, -175}, },
            {},
            {{45, 45, 286}, {46, 122, -25}, },
            {{9, 40, -177}, },
            {{9, 40, -177}, },
            {{9, 40, -177}, },
            {},
            {{45, 111, -100}, {112, 112, 287}, {113, 122, 61}, },
            {{9, 40, -178}, },
            {{9, 40, -178}, },
            {{9, 40, -178}, },
            {},
            {{45, 107, -33}, {108, 108, 288}, {109, 122, 61}, },
            {{45, 113, -41}, {114, 114, 289}, {115, 122, 61}, },
            {{45, 115, -66}, {116, 116, 290}, {117, 122, 61}, },
            {{45, 104, -68}, {105, 105, 291}, {106, 122, 61}, },
            {{45, 99, -36}, {100, 100, 292}, {101, 122, 61}, },
            {{45, 114, -72}, {115, 115, 293}, {116, 122, 61}, },
            {{9, 9, 294}, {10, 10, 295}, {13, 13, 296}, {40, 40, 297}, {45, 122, -25}, },
            {{45, 114, -72}, {115, 115, 298}, {116, 122, 61}, },
            {{45, 102, -127}, {103, 103, 299}, {104, 122, 61}, },
            {{45, 113, -41}, {114, 114, 300}, {115, 122, 61}, },
            {{45, 108, -70}, {109, 109, 301}, {110, 122, 61}, },
            {{9, 40, -199}, },
            {{9, 40, -199}, },
            {{9, 40, -199}, },
            {},
            {{45, 107, -33}, {108, 108, 302}, {109, 122, 61}, },
            {{9, 40, -201}, },
            {{9, 40, -201}, },
            {{9, 40, -201}, },
            {},
            {{45, 114, -72}, {115, 115, 303}, {116, 122, 61}, },
            {{45, 110, -30}, {111, 111, 304}, {112, 122, 61}, },
            {{45, 116, -93}, {117, 117, 305}, {118, 122, 61}, },
            {{45, 109, -29}, {110, 110, 306}, {111, 122, 61}, },
            {{45, 102, -127}, {103, 103, 307}, {104, 122, 61}, },
            {{45, 115, -66}, {116, 116, 308}, {117, 122, 61}, },
            {{9, 9, 309}, {10, 10, 310}, {13, 13, 311}, {40, 40, 312}, {45, 122, -25}, },
            {{45, 109, -29}, {110, 110, 313}, {111, 122, 61}, },
            {{9, 40, -211}, },
            {{9, 40, -211}, },
            {{9, 40, -211}, },
            {},
            {{45, 115, -66}, {116, 116, 314}, {117, 122, 61}, },
            {{45, 99, -36}, {100, 100, 315}, {101, 122, 61}, },
            {{45, 109, -29}, {110, 110, 316}, {111, 122, 61}, },
            {{45, 115, -66}, {116, 116, 317}, {117, 122, 61}, },
            {{9, 40, -216}, },
            {{9, 40, -216}, },
            {{9, 40, -216}, },
            {},
            {{9, 40, -217}, },
            {{9, 40, -217}, },
            {{9, 40, -217}, },
            {},
            {{45, 104, -68}, {105, 105, 318}, {106, 122, 61}, },
            {{45, 45, 319}, {46, 122, -25}, },
            {{45, 110, -30}, {111, 111, 320}, {112, 122, 61}, },
            {{45, 115, -66}, {116, 116, 321}, {117, 122, 61}, },
            {{45, 109, -29}, {110, 110, 322}, {111, 122, 61}, },
            {{45, 95, -25}, {97, 97, 323}, {98, 122, 61}, },
            {{45, 104, -68}, {105, 105, 324}, {106, 122, 61}, },
            {{9, 9, 325}, {10, 10, 326}, {13, 13, 327}, {40, 40, 328}, {45, 122, -25}, },
            {{45, 122, -25}, },
            {{45, 110, -30}, {111, 111, 329}, {112, 122, 61}, },
            {{45, 104, -68}, {105, 105, 330}, {106, 122, 61}, },
            {{45, 114, -72}, {115, 115, 331}, {116, 122, 61}, },
            {{9, 40, -246}, },
            {{9, 40, -246}, },
            {{9, 40, -246}, },
            {},
            {{45, 45, 332}, {46, 122, -25}, },
            {{9, 9, 333}, {10, 10, 334}, {13, 13, 335}, {40, 40, 336}, {45, 45, 337}, {46, 122, -25}, },
            {{45, 104, -68}, {105, 105, 338}, {106, 122, 61}, },
            {{45, 45, 339}, {46, 122, -25}, },
            {{45, 95, -25}, {97, 97, 340}, {98, 122, 61}, },
            {{45, 100, -31}, {101, 101, 341}, {102, 122, 61}, },
            {{45, 113, -41}, {114, 114, 342}, {115, 122, 61}, },
            {{45, 115, -66}, {116, 116, 343}, {117, 122, 61}, },
            {{9, 9, 344}, {10, 10, 345}, {13, 13, 346}, {40, 40, 347}, {45, 122, -25}, },
            {{9, 9, 348}, {10, 10, 349}, {13, 13, 350}, {40, 40, 351}, {45, 122, -25}, },
            {{9, 9, 352}, {10, 10, 353}, {13, 13, 354}, {40, 40, 355}, {45, 122, -25}, },
            {{9, 40, -266}, },
            {{9, 40, -266}, },
            {{9, 40, -266}, },
            {},
            {{45, 114, -72}, {115, 115, 356}, {116, 122, 61}, },
            {{9, 9, 357}, {10, 10, 358}, {13, 13, 359}, {40, 40, 360}, {45, 122, -25}, },
            {{45, 100, -31}, {101, 101, 361}, {102, 122, 61}, },
            {{45, 115, -66}, {116, 116, 362}, {117, 122, 61}, },
            {{45, 45, 363}, {46, 122, -25}, },
            {{45, 109, -29}, {110, 110, 364}, {111, 122, 61}, },
            {{45, 109, -29}, {110, 110, 365}, {111, 122, 61}, },
            {{45, 109, -29}, {110, 110, 366}, {111, 122, 61}, },
            {{45, 100, -31}, {101, 101, 367}, {102, 122, 61}, },
            {{45, 95, -25}, {97, 97, 368}, {98, 122, 61}, },
            {{45, 98, -65}, {99, 99, 369}, {100, 122, 61}, },
            {{45, 95, -25}, {97, 121, 61}, {122, 122, 370}, },
            {{9, 40, -291}, },
            {{9, 40, -291}, },
            {{9, 40, -291}, },
            {},
            {{45, 109, -29}, {110, 110, 371}, {111, 122, 61}, },
            {{45, 109, -29}, {110, 110, 372}, {111, 122, 61}, },
            {{45, 104, -68}, {105, 105, 373}, {106, 122, 61}, },
            {{45, 118, -218}, {119, 119, 374}, {120, 122, 61}, },
            {{9, 40, -301}, },
            {{9, 40, -301}, },
            {{9, 40, -301}, },
            {},
            {{45, 107, -33}, {108, 108, 375}, {109, 122, 61}, },
            {{45, 109, -29}, {110, 110, 376}, {111, 122, 61}, },
            {{45, 111, -100}, {112, 112, 377}, {113, 122, 61}, },
            {{45, 115, -66}, {116, 116, 378}, {117, 122, 61}, },
            {{45, 99, -36}, {100, 100, 379}, {101, 122, 61}, },
            {{45, 45, 380}, {46, 122, -25}, },
            {{45, 100, -31}, {101, 101, 381}, {102, 122, 61}, },
            {{9, 40, -308}, },
            {{9, 40, -308}, },
            {{9, 40, -308}, },
            {},
            {{9, 40, -309}, },
            {{9, 40, -309}, },
            {{9, 40, -309}, },
            {},
            {{9, 40, -310}, },
            {{9, 40, -310}, },
            {{9, 40, -310}, },
            {},
            {{9, 9, 382}, {10, 10, 383}, {13, 13, 384}, {40, 40, 385}, {45, 122, -25}, },
            {{9, 40, -316}, },
            {{9, 40, -316}, },
            {{9, 40, -316}, },
            {},
            {{45, 109, -29}, {110, 110, 386}, {111, 122, 61}, },
            {{9, 9, 387}, {10, 10, 388}, {13, 13, 389}, {40, 40, 390}, {45, 122, -25}, },
            {{45, 95, -25}, {97, 97, 391}, {98, 122, 61}, },
            {{45, 102, -127}, {103, 103, 392}, {104, 122, 61}, },
            {{45, 116, -93}, {117, 117, 393}, {118, 122, 61}, },
            {{45, 45, 394}, {46, 122, -25}, },
            {{45, 45, 395}, {46, 122, -25}, },
            {{45, 108, -70}, {109, 109, 396}, {110, 122, 61}, },
            {{45, 100, -31}, {101, 101, 397}, {102, 122, 61}, },
            {{45, 100, -31}, {101, 101, 398}, {102, 122, 61}, },
            {{9, 9, 399}, {10, 10, 400}, {13, 13, 401}, {40, 40, 402}, {45, 122, -25}, },
            {{45, 102, -127}, {103, 103, 403}, {104, 122, 61}, },
            {{45, 109, -29}, {110, 110, 404}, {111, 122, 61}, },
            {{45, 104, -68}, {105, 105, 405}, {106, 122, 61}, },
            {{45, 100, -31}, {101, 101, 406}, {102, 122, 61}, },
            {{45, 102, -127}, {103, 103, 407}, {104, 122, 61}, },
            {{45, 113, -41}, {114, 114, 408}, {115, 122, 61}, },
            {{45, 100, -31}, {101, 101, 409}, {102, 122, 61}, },
            {{45, 45, 410}, {46, 122, -25}, },
            {{45, 110, -30}, {111, 111, 411}, {112, 122, 61}, },
            {{45, 122, -25}, },
            {{9, 40, -358}, },
            {{9, 40, -358}, },
            {{9, 40, -358}, },
            {},
            {{45, 115, -66}, {116, 116, 412}, {117, 122, 61}, },
            {{9, 40, -364}, },
            {{9, 40, -364}, },
            {{9, 40, -364}, },
            {},
            {{45, 117, -73}, {118, 118, 413}, {119, 122, 61}, },
            {{45, 45, 414}, {46, 122, -25}, },
            {{45, 108, -70}, {109, 109, 415}, {110, 122, 61}, },
            {{45, 95, -25}, {97, 97, 416}, {98, 122, 61}, },
            {{45, 104, -68}, {105, 105, 417}, {106, 122, 61}, },
            {{45, 100, -31}, {101, 101, 418}, {102, 122, 61}, },
            {{45, 45, 419}, {46, 122, -25}, },
            {{45, 45, 420}, {46, 122, -25}, },
            {{9, 40, -373}, },
            {{9, 40, -373}, },
            {{9, 40, -373}, },
            {},
            {{45, 45, 421}, {46, 122, -25}, },
            {{45, 102, -127}, {103, 103, 422}, {104, 122, 61}, },
            {{45, 115, -66}, {116, 116, 423}, {117, 122, 61}, },
            {{45, 109, -29}, {110, 110, 424}, {111, 122, 61}, },
            {{9, 9, 425}, {10, 10, 426}, {13, 13, 427}, {40, 40, 428}, {45, 45, 429}, {46, 122, -25}, },
            {{45, 110, -30}, {111, 111, 430}, {112, 122, 61}, },
            {{9, 9, 431}, {10, 10, 432}, {13, 13, 433}, {40, 40, 434}, {45, 122, -25}, },
            {{45, 100, -31}, {101, 101, 435}, {102, 122, 61}, },
            {{45, 113, -41}, {114, 114, 436}, {115, 122, 61}, },
            {{45, 45, 437}, {46, 122, -25}, },
            {{45, 95, -25}, {97, 97, 438}, {98, 122, 61}, },
            {{45, 114, -72}, {115, 115, 439}, {116, 122, 61}, },
            {{45, 97, -96}, {98, 98, 440}, {99, 122, 61}, },
            {{45, 117, -73}, {118, 118, 441}, {119, 122, 61}, },
            {{45, 99, -36}, {100, 100, 442}, {101, 122, 61}, },
            {{9, 9, 443}, {10, 10, 444}, {13, 13, 445}, {40, 40, 446}, {45, 122, -25}, },
            {{45, 116, -93}, {117, 117, 447}, {118, 122, 61}, },
            {{45, 114, -72}, {115, 115, 448}, {116, 122, 61}, },
            {{45, 114, -72}, {115, 115, 449}, {116, 122, 61}, },
            {{45, 45, 450}, {46, 122, -25}, },
            {{45, 95, -25}, {97, 103, 61}, {104, 104, 451}, {105, 122, 61}, },
            {{45, 102, -127}, {103, 103, 452}, {104, 122, 61}, },
            {{9, 40, -409}, },
            {{9, 40, -409}, },
            {{9, 40, -409}, },
            {},
            {{45, 95, -25}, {97, 97, 453}, {98, 98, 454}, {99, 122, 61}, },
            {{45, 111, -100}, {112, 112, 455}, {113, 122, 61}, },
            {{9, 40, -411}, },
            {{9, 40, -411}, },
            {{9, 40, -411}, },
            {},
            {{45, 109, -29}, {110, 110, 456}, {111, 122, 61}, },
            {{45, 45, 457}, {46, 122, -25}, },
            {{45, 110, -30}, {111, 111, 458}, {112, 122, 61}, },
            {{45, 104, -68}, {105, 105, 459}, {106, 122, 61}, },
            {{45, 104, -68}, {105, 105, 460}, {106, 122, 61}, },
            {{45, 100, -31}, {101, 101, 461}, {102, 122, 61}, },
            {{45, 95, -25}, {97, 97, 462}, {98, 122, 61}, },
            {{9, 9, 463}, {10, 10, 464}, {13, 13, 465}, {40, 40, 466}, {45, 122, -25}, },
            {{9, 40, -420}, },
            {{9, 40, -420}, },
            {{9, 40, -420}, },
            {},
            {{45, 113, -41}, {114, 114, 467}, {115, 122, 61}, },
            {{45, 111, -100}, {112, 112, 468}, {113, 122, 61}, },
            {{45, 104, -68}, {105, 105, 469}, {106, 122, 61}, },
            {{45, 104, -68}, {105, 105, 470}, {106, 122, 61}, },
            {{9, 9, 471}, {10, 10, 472}, {13, 13, 473}, {40, 40, 474}, {45, 122, -25}, },
            {{45, 115, -66}, {116, 116, 475}, {117, 122, 61}, },
            {{45, 101, -141}, {102, 102, 476}, {103, 122, 61}, },
            {{45, 100, -31}, {101, 101, 477}, {102, 122, 61}, },
            {{45, 100, -31}, {101, 101, 478}, {102, 122, 61}, },
            {{45, 115, -66}, {116, 116, 479}, {117, 122, 61}, },
            {{45, 114, -72}, {115, 115, 480}, {116, 122, 61}, },
            {{45, 113, -41}, {114, 114, 481}, {115, 122, 61}, },
            {{45, 107, -33}, {108, 108, 482}, {109, 122, 61}, },
            {{45, 97, -96}, {98, 98, 483}, {99, 122, 61}, },
            {{45, 113, -41}, {114, 114, 484}, {115, 122, 61}, },
            {{45, 104, -68}, {105, 105, 485}, {106, 122, 61}, },
            {{9, 40, -444}, },
            {{9, 40, -444}, },
            {{9, 40, -444}, },
            {},
            {{45, 104, -68}, {105, 105, 486}, {106, 122, 61}, },
            {{45, 95, -25}, {97, 97, 487}, {98, 122, 61}, },
            {{45, 97, -96}, {98, 98, 488}, {99, 122, 61}, },
            {{45, 109, -29}, {110, 110, 489}, {111, 122, 61}, },
            {{9, 40, -453}, },
            {{9, 40, -453}, },
            {{9, 40, -453}, },
            {},
            {{45, 103, -425}, {104, 104, 490}, {105, 122, 61}, },
            {{45, 115, -66}, {116, 116, 491}, {117, 122, 61}, },
            {{45, 101, -141}, {102, 102, 492}, {103, 122, 61}, },
            {{45, 113, -41}, {114, 114, 493}, {115, 122, 61}, },
            {{45, 104, -68}, {105, 105, 494}, {106, 122, 61}, },
            {{45, 100, -31}, {101, 101, 495}, {102, 122, 61}, },
            {{45, 45, 496}, {46, 122, -25}, },
            {{45, 95, -25}, {97, 97, 497}, {98, 122, 61}, },
            {{45, 107, -33}, {108, 108, 498}, {109, 122, 61}, },
            {{9, 9, 499}, {10, 10, 500}, {13, 13, 501}, {40, 40, 502}, {45, 122, -25}, },
            {{45, 107, -33}, {108, 108, 503}, {109, 122, 61}, },
            {{9, 9, 504}, {10, 10, 505}, {13, 13, 506}, {40, 40, 507}, {45, 122, -25}, },
            {{45, 98, -65}, {99, 99, 508}, {100, 122, 61}, },
            {{45, 107, -33}, {108, 108, 509}, {109, 122, 61}, },
            {{45, 114, -72}, {115, 115, 510}, {116, 122, 61}, },
            {{9, 9, 511}, {10, 10, 512}, {13, 13, 513}, {40, 40, 514}, {45, 122, -25}, },
            {{45, 100, -31}, {101, 101, 515}, {102, 122, 61}, },
            {{45, 110, -30}, {111, 111, 516}, {112, 122, 61}, },
            {{45, 115, -66}, {116, 116, 517}, {117, 122, 61}, },
            {{45, 115, -66}, {116, 116, 518}, {117, 122, 61}, },
            {{45, 107, -33}, {108, 108, 519}, {109, 122, 61}, },
            {{45, 114, -72}, {115, 115, 520}, {116, 122, 61}, },
            {{45, 97, -96}, {98, 98, 521}, {99, 122, 61}, },
            {{45, 104, -68}, {105, 105, 522}, {106, 122, 61}, },
            {{9, 40, -486}, },
            {{9, 40, -486}, },
            {{9, 40, -486}, },
            {},
            {{45, 95, -25}, {97, 97, 523}, {98, 122, 61}, },
            {{9, 40, -488}, },
            {{9, 40, -488}, },
            {{9, 40, -488}, },
            {},
            {{45, 100, -31}, {101, 101, 524}, {102, 122, 61}, },
            {{45, 104, -68}, {105, 105, 525}, {106, 122, 61}, },
            {{45, 115, -66}, {116, 116, 526}, {117, 122, 61}, },
            {{9, 40, -492}, },
            {{9, 40, -492}, },
            {{9, 40, -492}, },
            {},
            {{45, 113, -41}, {114, 114, 527}, {115, 122, 61}, },
            {{45, 113, -41}, {114, 114, 528}, {115, 122, 61}, },
            {{45, 120, -82}, {121, 121, 529}, {122, 122, 61}, },
            {{45, 120, -82}, {121, 121, 530}, {122, 122, 61}, },
            {{45, 101, -141}, {102, 102, 531}, {103, 122, 61}, },
            {{45, 100, -31}, {101, 101, 532}, {102, 122, 61}, },
            {{45, 107, -33}, {108, 108, 533}, {109, 122, 61}, },
            {{45, 109, -29}, {110, 110, 534}, {111, 122, 61}, },
            {{45, 97, -96}, {98, 98, 535}, {99, 122, 61}, },
            {{9, 9, 536}, {10, 10, 537}, {13, 13, 538}, {40, 40, 539}, {45, 122, -25}, },
            {{45, 109, -29}, {110, 110, 540}, {111, 122, 61}, },
            {{45, 113, -41}, {114, 114, 541}, {115, 122, 61}, },
            {{9, 9, 542}, {10, 10, 543}, {13, 13, 544}, {40, 40, 545}, {45, 122, -25}, },
            {{45, 100, -31}, {101, 101, 546}, {102, 122, 61}, },
            {{9, 9, 547}, {10, 10, 548}, {13, 13, 549}, {40, 40, 550}, {45, 122, -25}, },
            {{45, 45, 551}, {46, 122, -25}, },
            {{45, 122, -25}, },
            {{45, 107, -33}, {108, 108, 552}, {109, 122, 61}, },
            {{45, 100, -31}, {101, 101, 553}, {102, 122, 61}, },
            {{45, 102, -127}, {103, 103, 554}, {104, 122, 61}, },
            {{45, 107, -33}, {108, 108, 555}, {109, 122, 61}, },
            {{9, 40, -526}, },
            {{9, 40, -526}, },
            {{9, 40, -526}, },
            {},
            {{45, 102, -127}, {103, 103, 556}, {104, 122, 61}, },
            {{45, 116, -93}, {117, 117, 557}, {118, 122, 61}, },
            {{9, 40, -529}, },
            {{9, 40, -529}, },
            {{9, 40, -529}, },
            {},
            {{9, 9, 558}, {10, 10, 559}, {13, 13, 560}, {40, 40, 561}, {45, 122, -25}, },
            {{9, 40, -531}, },
            {{9, 40, -531}, },
            {{9, 40, -531}, },
            {},
            {{45, 116, -93}, {117, 117, 562}, {118, 122, 61}, },
            {{45, 101, -141}, {102, 102, 563}, {103, 122, 61}, },
            {{9, 9, 564}, {10, 10, 565}, {13, 13, 566}, {40, 40, 567}, {45, 122, -25}, },
            {{45, 122, -25}, },
            {{45, 100, -31}, {101, 101, 568}, {102, 122, 61}, },
            {{45, 122, -25}, },
            {{45, 98, -65}, {99, 99, 569}, {100, 122, 61}, },
            {{9, 40, -548}, },
            {{9, 40, -548}, },
            {{9, 40, -548}, },
            {},
            {{45, 113, -41}, {114, 114, 570}, {115, 122, 61}, },
            {{45, 122, -25}, },
            {{9, 40, -555}, },
            {{9, 40, -555}, },
            {{9, 40, -555}, },
            {},
            {{9, 9, 571}, {10, 10, 572}, {13, 13, 573}, {40, 40, 574}, {45, 122, -25}, },
            {{45, 115, -66}, {116, 116, 575}, {117, 122, 61}, },
            {{45, 104, -68}, {105, 105, 576}, {106, 122, 61}, },
            {{9, 40, -570}, },
            {{9, 40, -570}, },
            {{9, 40, -570}, },
            {},
            {{45, 104, -68}, {105, 105, 577}, {106, 122, 61}, },
            {{9, 9, 578}, {10, 10, 579}, {13, 13, 580}, {40, 40, 581}, {45, 122, -25}, },
            {{45, 110, -30}, {111, 111, 582}, {112, 122, 61}, },
            {{9, 40, -578}, },
            {{9, 40, -578}, },
            {{9, 40, -578}, },
            {},
            {{45, 109, -29}, {110, 110, 583}, {111, 122, 61}, },
            {{9, 9, 584}, {10, 10, 585}, {13, 13, 586}, {40, 40, 587}, {45, 122, -25}, },
            {{9, 40, -585}, },
            {{9, 40, -585}, },
            {{9, 40, -585}, },
            {},
        }
    };*/

    private static int[][] accept;
/*  {
        // INITIAL
        {-1, 83, 83, 83, 83, -1, -1, 65, -1, 60, 61, 58, 74, 66, 75, 71, 68, 63, 57, 79, 76, 80, 64, 84, 69, 70, 84, 84, 84, 84, 84, 84, 84, 84, 84, 84, 84, 84, 84, 84, 84, 84, 84, 84, 84, 73, 77, -1, 62, -1, 62, 72, 63, 67, 63, 56, 81, 82, 84, 84, 84, 84, 84, 84, 84, 84, 84, 84, 84, 84, 84, 84, 84, 84, 84, 84, 84, 84, 84, 84, 84, 84, 84, 84, 84, 84, 84, 78, 84, 84, 84, 84, 84, 84, 84, 84, 84, 84, 84, 63, 84, 50, 84, 84, 84, 84, 84, 84, 84, 84, 84, 51, 84, 84, 84, 84, 84, 84, 84, 84, -1, -1, -1, 55, 84, 84, 84, 84, 52, 84, 84, 84, 84, 84, 84, 84, 84, 84, 84, 84, 84, 84, 84, 84, 84, 84, 84, 84, 84, 84, 84, 84, 84, 84, 84, 84, 84, 84, 84, 84, 84, 84, 84, 84, 84, 84, 84, 84, -1, -1, -1, 49, 84, 84, 84, 84, 84, 84, -1, -1, -1, 53, 84, 84, 84, 84, 84, 84, 46, 84, 84, 84, -1, -1, -1, 54, 84, 84, 84, 84, 84, 84, 84, 84, 84, 41, 84, 84, 84, 84, 84, 84, 84, 84, 84, 84, 84, 84, 84, 84, -1, -1, -1, 45, -1, -1, -1, 42, 84, -1, -1, -1, 44, 84, -1, -1, -1, 48, 84, 84, 84, 84, 84, 84, 84, 84, 84, 84, 84, -1, -1, -1, 47, 84, -1, -1, -1, 43, 84, 84, 84, 84, 84, 84, 84, 84, -1, -1, -1, 37, 84, 84, 84, 84, -1, -1, -1, 38, -1, -1, -1, 40, 84, 84, 84, 84, 84, 84, 84, 84, 34, 84, 84, 84, -1, -1, -1, 39, 84, 84, 84, 84, 84, 84, 84, 84, 84, 84, 84, -1, -1, -1, 36, 84, 84, 84, 84, 84, 84, 84, 84, 84, 84, 84, 84, -1, -1, -1, 15, 84, 84, 84, 84, -1, -1, -1, 35, 84, 84, 84, 84, 84, 29, 84, -1, -1, -1, 33, -1, -1, -1, 30, -1, -1, -1, 32, 84, -1, -1, -1, 31, 84, 84, 84, 84, 84, 84, 84, 84, 84, 84, 84, 84, 84, 84, 84, 84, 84, 84, 84, 84, 25, -1, -1, -1, 27, 84, -1, -1, -1, 26, 84, 21, 84, 84, 84, 84, 20, 84, -1, -1, -1, 28, 22, 84, 84, 84, 84, 84, 84, 84, 84, 18, 84, 84, 84, 84, 84, 84, 84, 84, 84, 84, 84, 84, -1, -1, -1, 24, 84, 84, -1, -1, -1, 23, 84, 84, 84, 84, 84, 84, 84, 84, -1, -1, -1, 19, 84, 84, 84, 84, 84, 84, 84, 84, 84, 84, 84, 84, 84, 84, 84, 84, -1, -1, -1, 16, 84, 84, 84, 84, -1, -1, -1, 17, 84, 84, 84, 84, 84, 84, 84, 84, 84, 84, 84, 84, 84, 84, 84, 84, 84, 84, 84, 84, 84, 84, 84, 84, -1, -1, -1, 14, 84, -1, -1, -1, 13, 84, 84, 84, -1, -1, -1, 12, 84, 84, 84, 84, 84, 84, 84, 84, 84, 84, 84, 84, 84, 84, 84, 84, 8, 84, 84, 84, 84, -1, -1, -1, 10, 84, 84, -1, -1, -1, 9, 84, -1, -1, -1, 11, 84, 84, 84, 4, 84, 5, 84, -1, -1, -1, 7, 84, 2, -1, -1, -1, 6, 84, 84, 84, -1, -1, -1, 3, 84, 84, 84, -1, -1, -1, 1, 84, 84, -1, -1, -1, 0, },

    };*/

    public static class State
    {
        public final static State INITIAL = new State(0);

        private int id;

        private State(int id)
        {
            this.id = id;
        }

        public int id()
        {
            return id;
        }
    }
}
